---
title: VisualViewport
slug: Web/API/VisualViewport
tags:
  - API
  - Experimental
  - Interface
  - Reference
  - Visual Viewport API
  - VisualViewport
  - viewport
---
<p>{{SeeCompatTable}}{{APIRef("Visual Viewport")}}</p>

<p>The <strong><code>VisualViewport</code></strong> interface of the <a href="/en-US/docs/Web/API/Visual_Viewport_API">Visual Viewport API</a> represents the visual viewport for a given window. For a page containing iframes, each iframe, as well as the containing page, will have a unique window object. Each window on a page will have a unique <code>VisualViewport</code> representing the properties associated with that window.</p>

<p>You can get a window's visual viewport using {{domxref("Window.visualViewport")}}.</p>

<div class="note">
<p><strong>Note</strong>: Only the top-level window has a visual viewport that's distinct from the layout viewport. Therefore, it's generally only the <code>VisualViewport</code> object of the top-level window that's useful. For an {{htmlelement("iframe")}}, visual viewport metrics like {{domxref("VisualViewport.width")}} always correspond to layout viewport metrics like {{domxref("Element.clientWidth", "document.documentElement.clientWidth")}}.</p>
</div>

<h2 id="Properties">Properties</h2>

<p><em><code>VisualViewport</code> also inherits properties from its parent, {{domxref("EventTarget")}}.</em></p>

<dl>
 <dt>{{domxref("VisualViewport.offsetLeft")}} {{readonlyinline}}</dt>
 <dd>Returns the offset of the left edge of the visual viewport from the left edge of the layout viewport in CSS pixels.</dd>
 <dt>{{domxref("VisualViewport.offsetTop")}} {{readonlyinline}}</dt>
 <dd>Returns the offset of the top edge of the visual viewport from the top edge of the layout viewport in CSS pixels.</dd>
 <dt>{{domxref("VisualViewport.pageLeft")}} {{readonlyinline}}</dt>
 <dd>Returns the x coordinate of the visual viewport relative to the initial containing block origin of the top edge in CSS pixels.</dd>
 <dt>{{domxref("VisualViewport.pageTop")}} {{readonlyinline}}</dt>
 <dd>Returns the y coordinate of the visual viewport relative to the initial containing block origin of the top edge in CSS pixels.</dd>
 <dt>{{domxref("VisualViewport.width")}} {{readonlyinline}}</dt>
 <dd>Returns the width of the visual viewport in CSS pixels.</dd>
 <dt>{{domxref("VisualViewport.height")}} {{readonlyinline}}</dt>
 <dd>Returns the height of the visual viewport in CSS pixels.</dd>
 <dt>{{domxref("VisualViewport.scale")}} {{readonlyinline}}</dt>
 <dd>Returns the pinch-zoom scaling factor applied to the visual viewport.</dd>
</dl>

<h2 id="Events">Events</h2>

<p>Listen to these events using <code><a href="/en-US/docs/Web/API/EventTarget/addEventListener">addEventListener()</a></code> or by assigning an event listener to the relevant <code>on<em>eventname</em></code> property of this interface.</p>

<dl>
 <dt><code><a href="/en-US/docs/Web/API/VisualViewport/resize_event">resize</a></code></dt>
 <dd>Fired when the visual viewport is resized.<br>
 Also available via the {{domxref("VisualViewport.onresize")}} property.</dd>
 <dt><code><a href="/en-US/docs/Web/API/VisualViewport/scroll_event">scroll</a></code></dt>
 <dd>Fired when the visual viewport is scrolled.<br>
 Also available via the {{domxref("VisualViewport.onscroll")}} property.</dd>
</dl>

<h2 id="Examples">Examples</h2>

<h3 id="Hiding_an_overlaid_box_on_zoom">Hiding an overlaid box on zoom</h3>

<p>This example, taken from the <a href="https://github.com/WICG/visual-viewport">Visual Viewport README</a>, shows how to write a simple bit of code that will hide an overlaid box (which might contain an advert, say) when the user zooms in. This is a nice way to improve the user experience when zooming in on pages. A <a href="https://wicg.github.io/visual-viewport/examples/hide-on-zoom.html">live sample</a>  is also available.</p>

<pre class="brush: js">var bottomBar = document.getElementById('bottombar');
var viewport = window.visualViewport;

function resizeHandler() {
   if (viewport.scale &gt; 1.3)
     bottomBar.style.display = "none";
   else
     bottomBar.style.display = "block";
}

window.visualViewport.addEventListener('resize', resizeHandler);</pre>

<h3 id="Simulating_position_device-fixed">Simulating position: device-fixed</h3>

<p>This example, also taken from the <a href="https://github.com/WICG/visual-viewport">Visual Viewport README</a>, shows how to use this API to simulate <code>position: device-fixed</code>, which fixes elements to the visual viewport. A <a href="https://wicg.github.io/visual-viewport/examples/fixed-to-viewport.html">live sample</a> is also available.</p>

<pre class="brush: js">var bottomBar = document.getElementById('bottombar');
var viewport = window.visualViewport;
function viewportHandler() {
  var layoutViewport = document.getElementById('layoutViewport');

  // Since the bar is position: fixed we need to offset it by the visual
  // viewport's offset from the layout viewport origin.
  var offsetLeft = viewport.offsetLeft;
  var offsetTop = viewport.height
              - layoutViewport.getBoundingClientRect().height
              + viewport.offsetTop;

  // You could also do this by setting style.left and style.top if you
  // use width: 100% instead.
  bottomBar.style.transform = 'translate(' +
                              offsetLeft + 'px,' +
                              offsetTop + 'px) ' +
                              'scale(' + 1/viewport.scale + ')'
}
window.visualViewport.addEventListener('scroll', viewportHandler);
window.visualViewport.addEventListener('resize', viewportHandler);</pre>

<div class="notecard note">
<p><strong>Note</strong>: This technique should be used with care; emulating <code>position: device-fixed</code> in this way can result in the fixed element flickering during scrolling.</p>
</div>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('Visual Viewport','#the-visualviewport-interface','VisualViewport')}}</td>
   <td>{{Spec2('Visual Viewport')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.VisualViewport")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="https://github.com/bokand/bokand.github.io/blob/master/web_viewports_explainer.md">Web Viewports Explainer</a> — useful explanation of web viewports concepts, including the difference between visual viewport and layout viewport.</li>
</ul>
